<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container class="splash-page">
      <q-page class="pl-fullpage row justify-center items-center" style="padding:5%">

        <q-dialog v-model="showError">
          <q-card>
            <q-card-section>
              <div class="text-h6">{{ $t("splash.error_title") }}</div>
            </q-card-section>

            <q-card-section class="q-pt-none">
              {{ errorRes }}
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat label="OK" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>

        <q-dialog v-model="showConfirmation">
          <q-card style="width: 500px; max-width: 50vw;">
            <q-card-section>
              <div class="text-h6">{{ $t("splash.confirm_email_title") }}</div>
            </q-card-section>

            <q-card-section class="q-pt-none">
              <p v-html="$t('splash.confirm_email_message', [email])"></p>
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat :label="$t('ok')" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>

        <div class="left-on-full">
          <div class="content" style="float: right">
            <h1 style="margin-top:0px; margin-bottom: 30px;">Paroli <span class="highlight"
                style="font-size:85px; margin-left:10px;">{{ sitename }}</span></h1>
            <div class="blurb">
              <p><strong>{{ $t('splash.blurb_hero') }}</strong></p>
              <p>{{ $t('splash.blurb_desc') }}</p>
            </div>
            <div class="splash-img-container">
              <img class="splash-img" src="../assets/placeholder.png" />
            </div>
          </div>
        </div>

        <div v-if="loginMode" class="right-on-full">
          <div style="max-width:600px">
            <q-form class="splash-form q-gutter-md login-form" @submit="onLogin">
              <h5>{{ $t("splash.login") }}</h5>
              <q-input :label="$t('required.email')" filled v-model="email"
                :rules="[(val) => (val && val.length > 0) || $t('empty.email')]" />
              <q-input :label="$t('required.password')" type="password" filled v-model="password"
                :rules="[(val) => (val && val.length > 0) || $t('empty.password')]" />
              <div class="row items-center">

                <div class="col-5">
                  <a href="#" @click="resendEmail()">{{ $t("splash.resend") }}</a>
                </div>

                <div class="col-7 text-right">
                  <q-btn dark style="margin-left: 0" color="primary" :label="$t('splash.login')" type="submit" />
                </div>
              </div>
            </q-form>
            <p style="width:100%; text-align: center; padding-top: 10px;"><a role="button" tabindex="0"
                style="color:white;" @click="flipLogin">{{ $t("splash.switch_to_create") }}</a></p>
          </div>
        </div>
        <div v-else class="right-on-full">
          <div style="max-width:600px">
            <q-form class="splash-form q-gutter-md login-form" @submit="doSignUp">
              <h5>{{ $t("splash.create_account") }}</h5>
              <q-input :label="$t('required.name')" filled v-model="name"
                :rules="[(val) => (val && val.length > 0) || $t('empty.name')]" />
              <q-input :label="$t('required.email')" filled v-model="email"
                :rules="[(val) => (val && val.length > 0) || $t('empty.email')]" />
              <div style="display: flex">
                <q-select filled :options="phoneNums" v-model="phoneCode" style="width:33%;" />
                <q-input style="width:67%;" :label="$t('required.phone_number')" filled type="number"
                  v-model="phoneNumber" :rules="[
                    (val) => (val && val.length > 0) || $t('empty.phone_number'),
                    (val) =>
                      validPhoneNumberRule(val) || $t('invalid.phone_number'),
                  ]" />
              </div>
              <q-input :label="$t('required.password')" type="password" filled v-model="password"
                :rules="[(val) => (val && val.length > 0) || $t('empty.password')]" />
              <div class="row items-center">

                <div class="col-5">
                  <a href="#" @click="resendEmail()">{{ $t("splash.resend") }}</a>
                </div>

                <div class="col-7 text-right">
                  <q-btn dark style="margin-left: 0" color="primary" :label="$t('splash.create_account')" type="submit" />
                </div>
              </div>
            </q-form>
            <p style="width:100%; text-align: center; padding-top: 10px;"><a role="button" tabindex="0"
                style="color:white;" @click="flipLogin">{{ $t("splash.switch_to_login") }}</a></p>
          </div>
        </div>

        <p class="info" v-html="$t('splash.blurb_research') + '<br>' + $t('splash.blurb_contact')"></p>
        <LanguagePicker :fullwidth="false" :textcolstyle="'text-white'"
          style="position:absolute; bottom:0; display:block;" />

      </q-page>
    </q-page-container>
  </q-layout>
</template>
<script>
import { phoneCodes, validPhoneNumber, parseNumber } from "../utils/phone";
import { validEmail } from "../utils/email";
import { auth, functions } from "../firebase";
import LanguagePicker from "../components/LanguagePicker.vue";

export default {
  name: "Login",
  data()
  {
    return {
      name: "",
      email: "",
      phoneNumber: "",
      password: "",
      loginMode: true,
      showError: false,
      showConfirmation: false,
      errorRes: "",
      phoneCode: {
        label: "",
        value: ""
      }
    };
  },
  mounted()
  {
    this.phoneCode = {
      label: `${this.orderedPhoneCodes[0].code} (${this.orderedPhoneCodes[0].country})`,
      value: this.orderedPhoneCodes[0]
    }
  },
  computed: {
    sitename() 
    {
      return process.env.VUE_APP_SITENAME;
    },
    orderedPhoneCodes()
    {
      return phoneCodes();
    },
    phoneNums()
    {
      return this.orderedPhoneCodes.map((phoneCode) => ({
        label: `${phoneCode.code} (${phoneCode.country})`,
        value: phoneCode,
      }))
    }
  },
  methods: {
    flipLogin()
    {
      this.loginMode = !this.loginMode;
    },
    async resendEmail() 
    {
      try 
      {
        if (!this.email)
        {
          this.$q.notify({
            type: "negative",
            message: this.$t("empty.email"),
          });
          return;
        }
        this.$q.loading.show();
        const resendFb = functions.httpsCallable("resendConfirmationEmail");
        await resendFb({
          Email: this.email,
          EmailSubject: this.$t("emails.confirmation.subject"),
          EmailBody: this.$t("emails.confirmation.body")
        });
        this.$q.notify({
          type: "positive",
          message: this.$t("signup.confirm_email_message", [this.email]),
        });

      }
      catch (error)
      {
        console.log(error)
        this.$q.notify({
          type: "negative",
          message: this.$t("signup.error_title"),
        });
      }
      finally 
      {
        this.$q.loading.hide();
      }

    },
    async onLogin()
    {
      console.log("Attempting to login", this.email);

      try
      {
        this.$q.loading.show();
        await auth.setPersistence('local');
        let loginRes = await auth.signInWithEmailAndPassword(this.email, this.password);

        if (!loginRes.user.emailVerified)
        {
          this.$q.notify({
            type: "negative",
            message: this.$t("splash.confirm_email_title"),
          });
          this.$q.loading.hide();
          return;
        }

        await this.$router.replace({ name: "Dashboard" });
        this.$q.loading.hide();
      }
      catch (error) 
      {
        this.$q.loading.hide();
        this.$q.notify({
          type: "negative",
          message: error.message,
        });
      }
    },
    async doSignUp()
    {
      this.$q.loading.show();
      try
      {
        const lang = this.$i18n.locale;

        const phoneNumber = parseNumber(
          this.phoneCode.value.code + this.phoneNumber.split(" ").join("")
        );

        const createUserFb = functions.httpsCallable("createUser");
        let result = await createUserFb({
          Name: this.name,
          Email: this.email,
          Password: this.password,
          Phone: `+${phoneNumber.countryCallingCode}${phoneNumber.nationalNumber}`,
          Country: this.phoneCode.value.country,
          Language: lang,
          EmailSubject: this.$t("emails.confirmation.subject"),
          EmailBody: this.$t("emails.confirmation.body")
        });

        this.$q.loading.hide();

        if (!result.data.success)
        {
          this.errorRes = result.data.error
          this.showError = true
        }
        else
        {
          this.showConfirmation = true;
        }
      }
      catch (e) 
      {
        this.handleError(e.message);
      }
    },
    validEmailRule(val)
    {
      return validEmail(val);
    },
    validPhoneNumberRule(val)
    {
      return validPhoneNumber(this.phoneCode.value.code, val);
    },
  },
  components: {
    LanguagePicker
  },
};
</script>
<style scoped>
.pl-fullpage {
  background: var(--q-color-primary);
  padding: 10%;
  color: white;
}

.left-on-full {
  width: 55%;
  margin: auto;
  text-align: left;
  display: inline-block;
}

.right-on-full {
  width: 45%;
  margin: auto;
  padding: 0% 3% 0% 7%;
  display: inline-block;
}

.content {
  max-width: 850px;
}

.blurb {
  font-size: 22px;
}

.splash-img-container {
  height: 380px;
  margin: auto;
  text-align: center;
  padding: 20px;
}

.splash-img {
  height: 100%;
}

.splash-form {
  background: white;
  border-radius: 15px;
  padding: 15px;
  color: var(--q-color-primary);
}

.highlight {
  color: var(--q-color-primary);
  background: white;
  box-shadow: 10px 0 0 white, -10px 0 0 white;
  padding: 5px 0;
}

.info {
  text-align: center;
  margin-top: 5px;
  margin-bottom: 5px;
}

@media only screen and (min-width: 1900px) {
  /* .left-on-full {
        margin-right: 50px;
    }
    .right-on-full {
        margin-left: 50px;
    } */
}


@media only screen and (max-width: 1050px) {
  .left-on-full {
    width: 100%;
  }

  .right-on-full {
    width: 75%;
    margin-top: 20px;
  }

  .splash-img-container {
    height: 300px;
  }

  h1 {
    text-align: center;
  }

  .info {
    margin-bottom: 50px;
  }
}

@media only screen and (max-width: 750px) {
  .right-on-full {
    width: 85%;
  }
}

@media only screen and (max-width: 550px) {
  .right-on-full {
    width: 95%;
  }
}

@media only screen and (max-width: 450px) {
  .right-on-full {
    width: 100%;
    padding: 0% 1% 0% 4%;
  }
}
</style>
